//---------------------------------------------------------------------------
#ifndef mainH
#define mainH

#define RESET 0
#define READY 1
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Grids.hpp>
#include <CheckLst.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include "vu.h"

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TPanel *Panel2;
        TSplitter *Splitter1;
        TPanel *Panel3;
        TSplitter *Splitter2;
        TPanel *Panel4;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TTabSheet *TabSheet3;
        TToolBar *ToolBar1;
        TToolButton *ToolButton1;
        TToolButton *ToolButton2;
        TToolButton *resetbtn;
        TToolButton *ToolButton4;
        TToolButton *stepbtn;
        TToolButton *runbtn;
        TToolButton *restartbtn;
        TToolButton *savebtn;
        TToolButton *ToolButton10;
        TImageList *ImageList1;
        TPageControl *PageControl2;
        TTabSheet *TabSheet4;
        TTabSheet *TabSheet5;
        TRadioGroup *RadioGroup1;
        TRadioButton *MemHex;
        TRadioButton *MemFloat;
        TStringGrid *memory;
        TStringGrid *code;
        TToolButton *ToolButton8;
        TToolButton *ToolButton11;
        TEdit *deb1;
        TOpenDialog *OpenDialog1;
        TSaveDialog *SaveDialog1;
        TToolButton *ToolButton12;
        TToolButton *ToolButton13;
        TToolButton *ToolButton14;
        TPopupMenu *pop1;
        TMenuItem *ToogleBreakPoint1;
        TMenuItem *EditLine1;
        TMenuItem *Helpontopic1;
        TTabSheet *TabSheet6;
        TMemo *debugm;
        TLabel *Label1;
        TEdit *rx;
        TEdit *ry;
        TEdit *rz;
        TEdit *rw;
        TEdit *rstall;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TComboBox *RegSeL;
        TLabel *Label7;
        TEdit *rlastr;
        TEdit *rlastw;
        TLabel *Label8;
        TRadioButton *MemInt;
        TButton *Button1;
        TRadioGroup *RadioGroup2;
        TRadioButton *vflp;
        TRadioButton *vfp0;
        TRadioButton *vfp4;
        TRadioButton *vfp12;
        TRadioButton *vfp15;
        TButton *Button2;
        TLabel *Label9;
        TEdit *clip3;
        TEdit *clip2;
        TEdit *clip1;
        TEdit *clip0;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label12;
        TLabel *Label13;
        TButton *ShowFlags;
        TMemo *InstrStatus;
        TLabel *Label14;
        TLabel *Label15;
        TEdit *fds;
        TEdit *fis;
        TEdit *fos;
        TEdit *fd;
        TEdit *fzs;
        TEdit *fss;
        TEdit *fus;
        TEdit *fi;
        TEdit *fo;
        TEdit *fu;
        TEdit *fs;
        TEdit *fz;
        TLabel *Label16;
        TEdit *MOf;
        TEdit *MUf;
        TEdit *MSf;
        TEdit *MZf;
        TLabel *Label17;
        TLabel *Label18;
        TLabel *Label19;
        TLabel *Label20;
        TRadioButton *vh;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall codeSelectCell(TObject *Sender, int ACol, int ARow,
          bool &CanSelect);
        void __fastcall codeMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall ToolButton1Click(TObject *Sender);
        void __fastcall ToolButton2Click(TObject *Sender);
        void __fastcall savebtnClick(TObject *Sender);
        void __fastcall resetbtnClick(TObject *Sender);
        void __fastcall RegSeLChange(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall memorySetEditText(TObject *Sender, int ACol,
        int ARow, const AnsiString Value);
        void __fastcall rwExit(TObject *Sender);
        void __fastcall rxExit(TObject *Sender);
        void __fastcall ryExit(TObject *Sender);
        void __fastcall rzExit(TObject *Sender);
        void __fastcall restartbtnClick(TObject *Sender);
        void __fastcall stepbtnClick(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall ShowFlagsClick(TObject *Sender);
        void __fastcall runbtnClick(TObject *Sender);
        void __fastcall ToolButton14Click(TObject *Sender);
        void __fastcall ToolButton12Click(TObject *Sender);

private:	// User declarations
public:		// User declarations
        int Status;
        char FileLoad[150];
        char MemoLoad[150];
        void __fastcall DrawProgram();
        void __fastcall SetBreakPoint(int row, int mode);        
        void __fastcall DrawMemory();
        static void DebugTic(int a, int b);
        int __fastcall LineInstruction(int a);
        void __fastcall DrawParam(VUParam &p, char *a);
        void __fastcall InstuctionStatus();
        __fastcall TForm1(TComponent* Owner);

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
